Subject: Re: bug#23483: 24.5; cygwin emacs w32 doesn not ask to save files when windows shuts down

From: Eli Zaretskii <[email-masked]>
Date: Sat, 14 May 2016 10:22:34 +0300

> From: "Strozzi, David J." <[email-masked]>
> CC: "[email-masked]" <[email-masked]>, "[email-masked]"
> 	<[email-masked]>
> Date: Fri, 13 May 2016 20:02:08 +0000
> 
> Hmmm, this doesn't sound like a great fix.  It's really a "failsafe", but not what Windows users expect.

Windows users expect that a program either asks or silently does The
Right Thing.  Emacs will now do the latter.  I don't see why we should
emulate annoying behavior of programs that insist on asking.  I have
always hated to answer gobs of these questions when I restart a busy
system.  Most of those questions are redundant anyway, e.g., if I
change the size of a column in an Excel spreadsheet.

> When you open the file again, how will you know that there's another auto-save file?  Will emacs tell you?

Yes, Emacs will tell you the file has auto-saved changes, and will
propose a command to restore them.

> What if you open the file in another program? Or you're editing source code / script and then make / run it, nothing will tell you about the auto-saved file.

But the system didn't just go down on its own, at least that's not
what happens frequently.  _You_ shut it down, so why won't you restore
the files after it comes up (or save them before you shut down) in the
first place?  It makes very little sense to me.

> Perhaps better is to have emacs simply abort a restart / shutdown and require the user to manually close emacs.

No, this is even worse.  When I want to restart my system, I want it
to come up quickly enough, and I frequently turn to other things while
it restarts.

> If it doesn't behave like other windows programs (query user to save unsaved files), then we have to remember emacs is special.  You could have a parameter for whether emacs aborts a windows shutdown, default to yes, and then users and consciously shut it off if they want.

The feature that got coded is a safety feature, a kind of fire escape.
Normally, you are expected to shut down Emacs before you turn off the
system.  For a "fire escape", having an option that controls it makes
no sense to me, because safety features should be always active.